include "Atari5200.inc"
include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"

ext yMod_
ext dotOffset_, Background_
ext BackgroundPattern_
ext DrawBlocks_
ext DisplayList0,DisplayList1
ext CHBAS

pDestination equ ZW0
pSource equ ZW1
pPattern equ ZW2
charCount equ ZB0

CharOffset equ CharHeight*Char_Background

dseg
CurrentVram:
    defb 0
CurrentCharRam:
    defb 0


; void InitBackground();
cseg
InitBackground_: public InitBackground_
    pha
        lda #high Vram1 | sta CurrentVram
        lda #high CharRam1 | sta CurrentCharRam

        lda #low DisplayList0 | sta SDLSTL
        lda #high DisplayList0 | sta SDLSTH
        lda #high CharRam0 | sta CHBAS
    pla
rts


; void UpdateBackgroundChars();
cseg
UpdateBackgroundChars_: public UpdateBackgroundChars_
    pha
        lda #low CharOffset | sta <pDestination
        lda CurrentCharRam | clc|adc #high CharOffset | sta <pDestination+1
        lda #low (BackgroundPattern_+7) | sta <pPattern
        lda #high (BackgroundPattern_+7) | sta <pPattern+1
        ldx #Char_Alter-Char_BackGround
        do
            lda <pPattern | sec|sbc dotOffset_ | sta <pSource
            lda <pPattern+1 | sbc #0 | sta <pSource+1
            ldy #0
            do
                lda (<pSource),y | sta (<pDestination),y | iny
                cpy #CharHeight
            while ne | wend
            lda <pPattern | clc|adc #15 | sta <pPattern
            lda <pPattern+1 | adc #0 | sta <pPattern+1

            lda <pDestination | clc|adc #CharHeight | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dex
        while ne | wend
    pla
rts


; void BackgroundToVram();
cseg
BackgroundToVram_: public BackgroundToVram_
    pha
        lda yMod_
        asl a | asl a | asl a  ;*8
        sta <pSource | lda #0 | sta <pSource+1
        asl <pSource | rol <pSource+1 ;16
        asl <pSource | rol <pSource+1 ;32
        lda <pSource | clc|adc #low Background_ | sta <pSource
        lda <pSource+1 | adc #high Background_ | sta <pSource+1

        lda #VramWidth*StatusHeight | sta <pDestination
        lda CurrentVram | sta <pDestination+1
        ldx #VramHeight-StatusHeight
        do
            ldy #0
            do
                lda (<pSource),y | sta (<pDestination),y | iny
                cpy #VramWidth
            while ne | wend
            lda <pSource | clc|adc #VramWidth | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #VramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dex
        while ne | wend

        jsr DrawBlocks_
        
        lda CurrentVram
        cmp #high Vram0
        if eq
            lda #high Vram1 | sta CurrentVram
            lda #low DisplayList0 | sta SDLSTL
            lda #high DisplayList0 | sta SDLSTH
        else
            lda #high Vram0 | sta CurrentVram
            lda #low DisplayList1 | sta SDLSTL
            lda #high DisplayList1 | sta SDLSTH
        endif
    pla
rts


; void SwitchChars();
cseg
SwitchChars_: public SwitchChars_
    pha
        lda CurrentCharRam
        cmp #high CharRam0
        if eq
            lda #high CharRam1 | sta CurrentCharRam
            lda #high CharRam0 | sta CHBAS
        else
            lda #high CharRam0 | sta CurrentCharRam
            lda #high CharRam1 | sta CHBAS
        endif
    pla
rts
