#include "Vram.h"
#include "Movable.h"
#include "Sprite.h"
#include "Stage.h"

bool IsNear(byte a, byte b)
{
    return (a - b) + 1 < 3;
}


bool IsNearXY(ptr<Movable> p1, ptr<Movable> p2)
{
    return
        (p1->x - p2->x) + 1 < 2 &&
        (p1->xd - p2->xd) + CoordRate / 2 < CoordRate &&
        (p1->y - p2->y) + 1 < 2 &&
        (p1->yd - p2->yd) + CoordRate / 2 < CoordRate;
}


void ShowMovable(ptr<Movable> pMovable, byte pattern, byte color)
{
    byte y;
    y = pMovable->y - topY;
    if (y < WindowHeight) {
        y = (y << CoordShift) + pMovable->yd + dotOffset + 16;
        if (y < 192 - 16 + 1) {
            byte x;
            x = (pMovable->x << CoordShift) + pMovable->xd;
            ShowSprite(pMovable->sprite, x, y, pattern, color);
            return;
        }
    }
    HideSprite(pMovable->sprite);
}