#include "Vram.h"
#include "Chars.h"
#include "CopyMemory.h"

extern const byte[] MonoPattern, ColorPattern;

static const byte[] PatternColorTable = {
	28, 3,
    16, 1,
	4, 3,
    0xff
};


void InitVram()
{
    InitBackground();
    {
        byte pattern;
        ptr<byte> pSource, pPattern;
        pattern = 0;
        pSource = PatternColorTable;
        pPattern = MonoPattern;
        while (pSource[0] != 0xff) {
            byte count, color;
            count = *pSource; ++pSource;
            color = *pSource; ++pSource;
            SetPatternMono(pPattern, pattern, color, count);
            pattern += count;
            pPattern += ((word)count) << 2;
        }
    }
    CopyMemory(CharRam1, CharRam0, PatternSize * Char_Background);
}


void Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c);
            ++c;
        }
        pVram += VramRowSize - 2;
    }
}
